Uses Crt, Dos;

{$F+}

{ COM1 : INTR = $0C, PORT = $3F8 }
{ COM2 : INTR = $0B, PORT = $2F8 }

const COMINTR = $0C;
      COMPORT = $3F8;

var
    bytenum : word;
    combytes : array[0..2] of byte;
    x, y : longint;
    button1, button2 : boolean;
    MouseHandler : procedure;

procedure MyMouseHandler; Interrupt;
var dx, dy : integer;
var inbyte : byte;
begin
  { Get the port byte }
  inbyte := Port[COMPORT];

  { Make sure we are properly "synched" }
  if (inbyte and 64) = 64 then bytenum := 0;

  { Store the byte and adjust bytenum }
  combytes[bytenum] := inbyte;
  inc(bytenum);

  { Have we received all 3 bytes? }
  if bytenum = 3 then
    begin
      { Yes, so process them }
      dx := (combytes[0] and 3) shl 6 + combytes[1];
      dy := (combytes[0] and 12) shl 4 + combytes[2];
      if dx >= 128 then dx := dx - 256;
      if dy >= 128 then dy := dy - 256;
      x := x + dx;
      y := y + dy;
      button1 := (combytes[0] And 32) <> 0;
      button2 := (combytes[0] And 16) <> 0;

      { And start on first byte again }
      bytenum := 0;
    end;

  { Acknowledge the interrupt }
  Port[$20] := $20;
end;

procedure InitMyDriver;
begin
  { Initialize the normal mouse handler }
  asm
    mov ax, 0
    int $33
  end;

  { Initialize some of the variables we'll be using }
  bytenum := 0;
  x := 0;
  y := 0;
  button1 := false;
  button2 := false;

  { Save the current mouse handler and set up our own }
  GetIntVec(COMINTR, @MouseHandler);            { Save old handler addr }
  SetIntVec(COMINTR, Addr(MyMouseHandler));     { Set new handler }
end;

procedure CleanUpMyDriver;
begin
  SetIntVec(COMINTR, @MouseHandler);    { Restore interrupt handler }
end;

begin
  ClrScr;
  InitMyDriver;
  while not keypressed do
    WriteLn(x : 5, y : 5, button1 : 7, button2 : 7);
  while keypressed do readkey;
  CleanUpMyDriver;
end.
