Uses Crt, Dos;
{ By Alexei A. Founze E-Mail: alexfru@chat.ru }
{$F+}

{ COM1 : INTR = $0C, PORT = $3F8 }
{ COM2 : INTR = $0B, PORT = $2F8 }

const COMINTR = $0C;
      COMPORT = $3F8;

var
    firsttime : boolean;
    bytenum : word;
    combytes : array[0..2] of byte;
    x, y : longint;
    button1, button2 : boolean;
    MouseHandler : procedure;
    IRQMask : Byte;

procedure MyMouseHandler; Interrupt;
var dx, dy : integer;
var inbyte : byte;
begin
  { Get the port byte }
  inbyte := Port[COMPORT];
  if firsttime then begin
    WriteLn (#13#10#7'Mouse sent character: "',chr(inbyte),'"');
    If inbyte = 77 then WriteLn ('Microsoft mouse'); { "M" = 77 }
    Delay (2000);
    firsttime := false
  end;

  { Make sure we are properly "synched" }
  if (inbyte and 64) = 64 then bytenum := 0;

  { Store the byte and adjust bytenum }
  combytes[bytenum] := inbyte;
  inc(bytenum);

  { Have we received all 3 bytes? }
  if bytenum = 3 then
    begin
      { Yes, so process them }
      dx := (combytes[0] and 3) shl 6 + combytes[1];
      dy := (combytes[0] and 12) shl 4 + combytes[2];
      if dx >= 128 then dx := dx - 256;
      if dy >= 128 then dy := dy - 256;
      x := x + dx;
      y := y + dy;
      button1 := (combytes[0] And 32) <> 0;
      button2 := (combytes[0] And 16) <> 0;

      { And start on first byte again }
      bytenum := 0;
    end;

  { Acknowledge the interrupt }
  Port[$20] := $20;
end;

procedure InitMyDriver;
begin

  { Initialize some of the variables we'll be using }
  bytenum := 0;
  x := 0;
  y := 0;
  button1 := false;
  button2 := false;

  Port[COMPORT+3] := $80;               { start programming }
  Port[COMPORT+1] := 0;                 { 1200 }
  Port[COMPORT+0] := 96;                { bauds }
  Port[COMPORT+3] := 2+0+0;             { 7 bit word, 1 stop bit, no parity }
  Port[COMPORT+4] := 0;                 { Turn power off if was on }
  delay (10);
  Port[COMPORT+4] := 8+2+1;             { enable interrupt & turn power on (RTS,DTR) }
  Port[COMPORT+1] := 1;                 { enable interrupt }

  { Save the current mouse handler and set up our own }
  GetIntVec(COMINTR, @MouseHandler);            { Save old handler addr }
  SetIntVec(COMINTR, Addr(MyMouseHandler));     { Set new handler }
  IRQMask := Port[$21];
  If COMINTR = $0C then Port[$21] := IRQMask and $EF
  Else Port[$21] := IRQMask and $F7;            { Enable interrupt }
  firsttime := true
end;

procedure CleanUpMyDriver;
begin
  SetIntVec(COMINTR, @MouseHandler);    { Restore interrupt handler }
  Port[COMPORT+4] := 0;                 { Turn of mouse power }
  Port[$21] := IRQMask;                 { Restore interrupt mask state }
  { Initialize the normal mouse handler }
  asm
    mov ax, 0
    int $33
  end;
end;

begin
  ClrScr;
  InitMyDriver;
  while not keypressed do
    WriteLn(x : 5, y : 5, button1 : 7, button2 : 7);
  while keypressed do readkey;
  CleanUpMyDriver;
end.
